namespace Ora.API
{
    /// <summary>
    /// The basic component of Ora. Most of the interesting details are in
    /// IAnonymousGrouping. This just adds naming so the user can select them
    /// in the GUI. Inherit from this class to create your own grouping in Ora.
    /// </summary>
    public interface IGrouping : IAnonymousGrouping
    {
        /// <summary>
        /// The human-readable name in the author's preferred language.
        /// </summary>
        string Name { get; }
    }
}