using System.Drawing;
using EnvDTE80;

namespace Ora.API
{
    /// <summary>
    /// Very simple abstraction over a tree control for the purposes of adding
    /// grouping results to it.
    /// </summary>
    public interface IResultsTreeNode
    {
        /// <summary>
        /// Adds a single member as a tree node.
        /// </summary>
        /// <param name="member">The member to add</param>
        void Add(CodeElement2 member);

        /// <summary>
        /// Adds and returns a new tree node with the specified label and icon.
        /// </summary>
        /// <param name="label">The label for the new node</param>
        /// <param name="image">The icon for the new node</param>
        /// <returns></returns>
        IResultsTreeNode Add(string label, Bitmap image);

        bool ShouldAbort { get; }
    }
}