using System.Collections.Generic;
using System.Linq;
using EnvDTE;
using EnvDTE80;
using Ora;
using Ora.API;

namespace Ora.Groupings
{
    public class Access : IGrouping
    {
        public string Name
        {
            get { return "Access"; }
        }

        public IAnonymousGrouping NextInChain { get; set; }
        
        public void Generate(IResultsTreeNode node, IEnumerable<CodeElement2> members, CodeElement2 parent)
        {
            Add(node, members, parent, "public", vsCMAccess.vsCMAccessPublic);
            Add(node, members, parent, "protected", vsCMAccess.vsCMAccessProtected);
            Add(node, members, parent, "private", vsCMAccess.vsCMAccessPrivate);
            Add(node, members, parent, "internal", vsCMAccess.vsCMAccessProject);
        }

        private void Add(IResultsTreeNode node, IEnumerable<CodeElement2> members,
                         CodeElement2 parent, string name, vsCMAccess access)
        {
            NextInChain.Generate(node.Add(name, null), members.Where(member => member.GetMemberKind().GetAccess(member) == access), parent);
        }
    }
}