using System.Collections.Generic;
using System.Linq;
using EnvDTE80;
using Ora.API;
using Ora;

namespace Ora.Groupings
{
    public class Kind : IGrouping
    {
        public string Name
        {
            get { return "Kind"; }
        }

        public IAnonymousGrouping NextInChain { get; set; }

        public void Generate(IResultsTreeNode node, IEnumerable<CodeElement2> members, CodeElement2 parent)
        {
            foreach (IMemberKind kind in CodeElementExtensions.MemberKinds)
            {
                if (node.ShouldAbort)
                    return;

                NextInChain.Generate(node.Add(kind.Name, null), 
                                     members.Where(member => member.Kind == kind.Kind),
                                     parent);
            }
        }
    }
}