﻿using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace Ora
{
    public class Images
    {
        private readonly ImageList _list = new ImageList { ColorDepth = ColorDepth.Depth24Bit };

        private readonly Dictionary<Bitmap, int> _indexes = new Dictionary<Bitmap, int>();

        public int this[Bitmap image]
        {
            get
            {
                int index;
                if (!_indexes.TryGetValue(image, out index))
                {
                    index = _list.Images.Count;
                    _list.Images.Add(image);
                    _indexes[image] = index;
                }
                return index;
            }
        }

        public ImageList List
        {
            get { return _list; }
        }

        public static readonly Bitmap DefaultImage = Icons.Properties.Resources.Filter;
    }
}
