using System.Drawing;
using EnvDTE;
using EnvDTE80;
using Ora.API;

namespace Ora
{
    public abstract class MemberKindBase<T> : IMemberKind
    {
        private readonly vsCMElement _kind;
        private readonly string _name;

        protected MemberKindBase(vsCMElement kind, string name)
        {
            _kind = kind;
            _name = name;
        }

        public vsCMElement Kind
        {
            get { return _kind; }
        }

        public string Name
        {
            get { return _name; }
        }

        public virtual Bitmap Image
        {
            get { return null; }
        }

        public string GetCaption(CodeElement2 element)
        {
            return GetCaption((T)element);
        }

        public vsCMAccess GetAccess(CodeElement2 element)
        {
            return GetAccess((T)element);
        }

        public CodeInterface2 GetInterface(CodeElement2 element, CodeElement2 parent)
        {
            return GetInterface((T)element, parent);
        }

        protected abstract string GetCaption(T element);

        protected abstract vsCMAccess GetAccess(T element);

        protected virtual CodeInterface2 GetInterface(T element, CodeElement2 parent)
        {
            return null;
        }
    }
}