using System.Drawing;
using EnvDTE;
using EnvDTE80;

namespace Ora.MemberKinds
{
    public class MemberEvent : MemberKindBase<CodeEvent>
    {
        public MemberEvent()
            : base(vsCMElement.vsCMElementEvent, "event") { }

        protected override string GetCaption(CodeEvent element)
        {
            return element.Name;
        }

        protected override vsCMAccess GetAccess(CodeEvent element)
        {
            return element.Access;
        }

        public override Bitmap Image
        {
            get { return _bitmap; }
        }

        private static readonly Bitmap _bitmap = Icons.Properties.Resources.Event;

        protected override CodeInterface2 GetInterface(CodeEvent evt, CodeElement2 parent)
        {
            return ((CodeElement2)evt).GetAssociatedInterface(parent, mem =>
            {
                CodeEvent evtMember = mem as CodeEvent;
                if (evtMember != null)
                    return evtMember.Type.AsFullName + " " + EnvDTEExtensions.TrimType(evtMember.Name);
                return null;
            });
        }
    }
}