using System.Drawing;
using EnvDTE;
using EnvDTE80;

namespace Ora.MemberKinds
{
    public class MemberProperty : MemberKindBase<CodeProperty>
    {
        public MemberProperty()
            : base(vsCMElement.vsCMElementProperty, "property") { }

        protected override string GetCaption(CodeProperty element)
        {
            return element.Name + " : " + EnvDTEExtensions.TrimType(element.Type.AsFullName);
        }

        protected override vsCMAccess GetAccess(CodeProperty element)
        {
            return element.Access;
        }

        public override Bitmap Image
        {
            get { return _bitmap; }
        }

        private static readonly Bitmap _bitmap = Icons.Properties.Resources.Property;

        protected override CodeInterface2 GetInterface(CodeProperty prop, CodeElement2 parent)
        {
            return ((CodeElement2)prop).GetAssociatedInterface(parent, mem =>
                {
                    CodeProperty propMember = mem as CodeProperty;
                    if (propMember != null)
                        return propMember.Type.AsFullName + " " + EnvDTEExtensions.TrimType(propMember.Name);
                    return null;
                });
        }
    }
}