﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Ora;
using Ora.MemberKinds;

namespace OraTests
{
    [TestClass]
    public class StringManipulation
    {
        [TestMethod]
        public void MemberFunction_TrimType()
        {
            Assert.AreEqual("", EnvDTEExtensions.TrimType(""));
            Assert.AreEqual("A", EnvDTEExtensions.TrimType("A"));
            Assert.AreEqual("Ab", EnvDTEExtensions.TrimType("Ab"));
            Assert.AreEqual("A<b", EnvDTEExtensions.TrimType("A<b"));
            Assert.AreEqual("A<b>", EnvDTEExtensions.TrimType("A<b>"));
            Assert.AreEqual("A<b>", EnvDTEExtensions.TrimType("A <b > "));
            Assert.AreEqual("A<b,c>", EnvDTEExtensions.TrimType(" A<b ,c >"));
            Assert.AreEqual("x<b,c>", EnvDTEExtensions.TrimType("A.x <b ,c> "));
            Assert.AreEqual("x<y,z>", EnvDTEExtensions.TrimType("A.x <b.p.y ,c.z> "));
            Assert.AreEqual("m<y<n>,z>", EnvDTEExtensions.TrimType("A.x.m <b.p.y<r.n>,c.z> "));
        }
    }
}
