using System.Collections.Generic;
using System.Linq;
using System.Reflection;

namespace Reflect
{
    /// <summary>
    /// Hosts a list of all the related assemblies.
    /// </summary>
    public static class Assemblies
    {
        private static readonly List<Assembly> _assemblies = typeof (Assemblies).GetRelatedAssemblies().ToList();

        /// <summary>
        /// Returns every assembly in the same directory as this one (including this one).
        /// </summary>
        public static IEnumerable<Assembly> All
        {
            get { return _assemblies; }
        }
    }
}