using System;
using System.Collections.Generic;
using System.Linq;

namespace Reflect
{
    /// <summary>
    /// Hosts a list of all types in the program.
    /// </summary>
    public static class Types
    {
        private static readonly List<Type> _types = Assemblies.All.GetTypes().ToList();

        /// <summary>
        /// Returns a list of all types in all the assemblies in the same directory as this one.
        /// </summary>
        public static IEnumerable<Type> All
        {
            get { return _types; }
        }
    }
}