﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Threading;
using System.Xml;

namespace VersionCheck
{
    public static class FeedClient
	{
        public static IEnumerable<string> ReadTitles(string url)
        {
            WebRequest request = WebRequest.Create(url);
			request.Proxy = null;
			request.Credentials = CredentialCache.DefaultCredentials;

			HttpWebResponse response = (HttpWebResponse)request.GetResponse();
		    XmlReader xml = XmlReader.Create(response.GetResponseStream());

            try
            {
                while (xml.Read())
                {
                    if (xml.NodeType == XmlNodeType.Element && xml.Name == "title")
                    {
                        if (xml.Read())
                            yield return xml.Value;
                    }
                }    
            }
            finally
            {
                response.Close();
            }
		}
	}
}