using System.Collections.Generic;

namespace VersionCheck
{
    public static class Versioning
    {
        public static int ExtractBuildNumber(string title)
        {
            string[] parts = title.Split(' ');

            for (int n = 0; n < parts.Length; n++)
            {
                if (parts[n].ToLower() == "build")
                {
                    n++;
                    if (n < parts.Length)
                    {
                        int number;
                        if (int.TryParse(parts[n], out number))
                            return number;
                    }

                }
            }

            return 0;
        }

        public static int GetLatestBuildNumber(IEnumerable<string> titles)
        {
            foreach (string title in titles)
            {
                int build = ExtractBuildNumber(title);
                if (build != 0)
                    return build;
            }

            return 0;
        }
    }
}